



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++学习22 多态的概念及前提条件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++学习22 多态的概念及前提条件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-24 10:04:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在《<a href="http://c.biancheng.net/cpp/biancheng/view/2986.html" rel="external nofollow noreferrer">C++基类和派生类的赋值</a>》一节中讲到，基类的指针也可以指向派生类对象。请看下面的例子：</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
using namespace std;<br />
class People{<br />
protected:<br />
    char *name;<br />
public:<br />
    People(char *name):name(name){}<br />
    void display(){ cout&lt;&lt;"People: "&lt;&lt;name&lt;&lt;endl;}<br />
};<br />
class Student: public People{<br />
public:<br />
    Student(char *name):People(name){}<br />
    void display(){ cout&lt;&lt;"Student: "&lt;&lt;name&lt;&lt;endl;}<br />
};<br />
int main(){<br />
    People *p = new People("Xiao Ming");<br />
    p-&gt;display();<br />
    p = new Student("Li Lei");<br />
    p-&gt;display();<br />
    return ;<br />
}</pre>
</div>
<p>运行结果：<br />People: Xiao Ming<br />People: Li Lei</p>
<p>我们通常认为，如果指针指向了派生类对象，那么就应该使用派生类的成员变量和成员函数，这符合人们的思维习惯。</p>
<p>但是本例的运行结果却告诉我们：当基类指针 p 指向派生类 Student 的对象时，虽然使用了 Student 的成员变量，但是却没有使用它的成员函数，造成输出结果不伦不类，不符合我们的预期。</p>
<p>如果希望通过 p 指针访问 Student 类的成员函数，可以将该成员函数声明为虚函数，请看下面的代码：</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
using namespace std;<br />
class People{<br />
protected:<br />
    char *name;<br />
public:<br />
    People(char *name):name(name){}<br />
    //加virtual关键字声明为虚函数<br />
    virtual void display(){ cout&lt;&lt;"People: "&lt;&lt;name&lt;&lt;endl;}<br />
};<br />
class Student: public People{<br />
public:<br />
    Student(char *name):People(name){}<br />
    //加virtual关键字声明为虚函数<br />
    virtual void display(){ cout&lt;&lt;"Student: "&lt;&lt;name&lt;&lt;endl;}<br />
};<br />
int main(){<br />
    People *p = new People("Xiao Ming");<br />
    p-&gt;display();<br />
    p = new Student("Li Lei");<br />
    p-&gt;display();<br />
    return ;<br />
}</pre>
</div>
<p>运行结果：<br />People: Xiao Ming<br />Student: Li Lei</p>
<p>与上面的代码相比，这段代码仅仅是在 display() 函数声明前加了一个&nbsp;virtual&nbsp;关键字，将成员函数声明为了虚函数（Virtual Function）。这样，就可以通过 p 指针调用 Student 类的成员函数了，运行结果也证明了这一点。</p>
<p>借助虚函数，基类指针既可以使用基类的成员函数，也可以使用派生类的成员函数，它有多种形态，或多种表现方式，这就是多态（Polymorphism）。</p>
<p>上面的代码中，同样是<code>p-&gt;display();</code>这条语句，当 p 指向不同的对象时，它执行的操作是不一样的。同一条语句可以执行不同的操作，看起来有不同表现方式，这就是多态</p>
<p>多态是面向对象的主要特征之一。在C++中，虚函数的唯一用处就是构成多态。</p>
<p>C++提供多态的目的是：可以通过基类指针对所有派生类（包括直接派生和间接派生）的成员变量和成员函数进行&ldquo;全方位&rdquo;的访问，尤其是成员函数。如果没有多态，我们只能访问成员变量。</p>
<h2>构成多态的条件</h2>
<p>多态存在的三个条件：</p>
<ul><li>必须存在继承关系；</li>
<li>继承关系中必须有同名的虚函数，并且它们是覆盖关系（重载不行）。</li>
<li>存在基类的指针，通过该指针调用虚函数。</li></ul>
<p>注意：派生类中的虚函数必须覆盖（不是重载）基类中的虚函数，才能通过基类指针访问。请看下面的代码：</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
using namespace std;<br />
class Base{<br />
public:<br />
    void a(){ cout&lt;&lt;"Base::a()"&lt;&lt;endl; }<br />
    virtual void b(){ cout&lt;&lt;"Base::b()"&lt;&lt;endl; }<br />
    virtual void c(){ cout&lt;&lt;"Base::c()"&lt;&lt;endl; }<br />
};<br />
class Derived: public Base{<br />
public:<br />
    //覆盖基类普通成员函数，不构成多态<br />
    void a(){ cout&lt;&lt;"Derived::a()"&lt;&lt;endl; }<br />
    //覆盖基类虚函数，构成多态<br />
    virtual void b(){ cout&lt;&lt;"Derived::b()"&lt;&lt;endl; }<br />
    //重载基类虚函数，不构成多态<br />
    virtual void c(int n){ cout&lt;&lt;"Derived::c()"&lt;&lt;endl; }<br />
    //派生类新增函数<br />
    int d(){ cout&lt;&lt;"Derived::d()"&lt;&lt;endl; }<br />
};<br />
int main(){<br />
    Base *p = new Derived;<br />
    p -&gt; a();<br />
    p -&gt; b();<br />
    p -&gt; c();  //Compile Error<br />
    p -&gt; d();  //Compile Error<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j2xz48.html">code forces 383 Arpa&amp;&num;39&semi;s loud Owf and Mehrdad&amp;&num;39&semi;s evil plan&lpar;有向图最小环&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r933n109.html">【转载】Adapter用法总结大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jdmpl9.html">nodejs支持ssi实现include shtml页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okd1019.html">也可以使用如下命令更改您的默认 Shell</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dk0j9.html">Java - 使用 XSD 校验 XML</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdrjwr8.html">OpenGL旋转平移 变换</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pokz48.html">iOS学习&mdash;&mdash;iOS国际化（十二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojd475q.html">windows下如何快速搭建web&period;py开发框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj0xg38.html">fopen&lpar;&rpar;函数参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m0wl48.html">&lbrack;TJOI 2013&rsqb;单词</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1k7x8.html">jquery post跨域请求数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjme1k8.html">Android开发阅读文档资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1l64yq.html">（Python3）  连加 连乘  代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1lkr5q.html">leetcode39</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o12yz5q.html">Vue 爬坑之路（十二）&mdash;&mdash; vue-cli 3&period;x 搭建项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lny3q.html">linux装sqlite3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyj3xxq.html">Angular4&period;X 介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1wrne9.html">Django 之多对多关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql11zee9.html">jquery判断某个属性是否存在 hasAttr</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkrzkd8.html">windows 命令行中使用winrar</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90vmo5m8.html">JS之变量的运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdgjnr8.html">Linq的Distinct方法的扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjd1kd9.html">window&period;parent与window&period;openner</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmjmyl9.html">ExtJs学习之Window</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok1j4p9.html">apache commons vfs 文件夹监控</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdvjor8.html">Review Board&mdash;&mdash;在线代码审查工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1yojx9.html">HTML 打印 javascript连续打印 分页</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok14n59.html">Spring boot配合Spring session&lpar;redis&rpar;遇到的错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o031y9.html">【jmeter】逻辑控制器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxndllj8.html">c&num; 中的多线程和异步</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
